package cz.muni.fi.pv239.firstapp.myapplication2.app;

import android.app.AlarmManager;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.media.RingtoneManager;
import android.os.Build;
import android.support.v4.app.NotificationCompat;
import android.widget.Toast;


public class AlarmReceiver extends BroadcastReceiver
{

    @Override
    public void onReceive(Context context, Intent intent)
    {
        Toast.makeText(context,"onReceive",Toast.LENGTH_SHORT).show();
        throwNotification(context);
        final Intent i = new Intent(context, RefreshService.class);
        context.startService(i);
    }

    NotificationManager getNotificationManager(Context context)
    {
        return (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
    }

    private PendingIntent getPendingIntent(Context context, int id)
    {
        Intent intent = new Intent(context, MainActivity.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_PREVIOUS_IS_TOP);
        return PendingIntent.getActivity(context, id, intent, 0);
    }

    public void registerAlarm(Context c) throws IllegalArgumentException
    {

        AlarmManager am = (AlarmManager) c.getSystemService(Context.ALARM_SERVICE);
        Intent intent = new Intent(c, AlarmReceiver.class);
        PendingIntent pi = PendingIntent.getBroadcast(c, 0, intent, 0);
        am.setRepeating(AlarmManager.RTC, System.currentTimeMillis() + 50000, 50000, pi);



    }


    private void throwNotification(Context context)
    {
        Toast.makeText(context,"throwing notificaiton",Toast.LENGTH_SHORT).show();

        NotificationCompat.Builder builder = new NotificationCompat.Builder(context).setContentText("UpdatingDatabase")
                                                 .setContentTitle(context.getText(R.string.app_name))
                                                 .setSmallIcon(Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB ? R.drawable.ic_launcher : R.drawable.ic_launcher)
                                                 .setAutoCancel(true).setContentIntent(getPendingIntent(context, 0)).setWhen(System.currentTimeMillis())
                                                 .setDefaults(Notification.FLAG_AUTO_CANCEL|Notification.FLAG_SHOW_LIGHTS)
                                                 .setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION));



        Notification notification = builder.getNotification();
        NotificationManager notificationManager = getNotificationManager(context);

        notificationManager.notify(0, notification);

    }
}
