package cz.muni.fi.pv239.firstapp.myapplication2.app;

import android.os.Bundle;
import android.support.v4.app.FragmentTransaction;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;

import java.util.ArrayList;

import cz.muni.fi.pv239.firstapp.myapplication2.app.fragments.MyDetailFragment;
import cz.muni.fi.pv239.firstapp.myapplication2.app.fragments.MyListFragment;

public class MainActivity extends ActionBarActivity implements MyListFragment.OnListItemSelectedListener
{
    public static ArrayList<Student> students = new ArrayList<Student>();

    public static long mainThreadID;

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_main);

        AlarmReceiver alarmReceiver = new AlarmReceiver();
        alarmReceiver.registerAlarm(getApplicationContext());

        mainThreadID = Thread.currentThread().getId();
        Log.i("Main", "mainThreadID:" + mainThreadID);

        //SAVED INSTANCE STATE!!!
        if (savedInstanceState == null)
        {
            if (findViewById(R.id.fragment_container) != null)
            {

                MyListFragment firstFragment = new MyListFragment();
                getSupportFragmentManager()
                    .beginTransaction()
                    .add(R.id.fragment_container, firstFragment)
                    .commit();

            }
        }

    }

    //rozdiel medzi actionbaractivity a fragmentactivity
    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
        getMenuInflater().inflate(R.menu.main, menu);
        return super.onCreateOptionsMenu(menu);
    }


    @Override
    public void onListItemSelected(int position)
    {

        // The user selected the headline of an article from the HeadlinesFragment

        // Capture the article fragment from the activity layout
        MyDetailFragment detailFragment = (MyDetailFragment)
                                              getSupportFragmentManager().findFragmentById(R.id.detail_fragment);

        if (detailFragment != null)
        {
            // If article frag is available, we're in two-pane layout...

            // Call a method in the ArticleFragment to update its content
            detailFragment.updateView(position);

        } else
        {
            // If the frag is not available, we're in the one-pane layout and must swap frags...

            // Create fragment and give it an argument for the selected article
            MyDetailFragment newFragment = new MyDetailFragment();
            Bundle args = new Bundle();
            args.putInt(MyDetailFragment.ARG_POSITION, position);
            newFragment.setArguments(args);
            FragmentTransaction transaction = getSupportFragmentManager().beginTransaction();

            // Replace whatever is in the fragment_container view with this fragment,
            // and add the transaction to the back stack so the user can navigate back
            transaction.replace(R.id.fragment_container, newFragment);
            transaction.addToBackStack(null);

            // Commit the transaction
            transaction.commit();
        }

    }
}
