package cz.muni.fi.pv239.firstapp.myapplication2.app;

import android.content.Context;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.io.FileNotFoundException;
import java.io.InputStream;

import cz.muni.fi.pv239.firstapp.myapplication2.app.database.Provider;

/**
 * Created by Wendy on 10.3.14.
 */
public class MyAdapter extends CursorAdapter
{
    LayoutInflater inflater;

    public MyAdapter(Context context, Cursor cursor, boolean autoRequery)
    {
        super(context, cursor, autoRequery);
        inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

    }

    @Override public long getItemId(int position)
    {
        Cursor cursor = getCursor();
        cursor.moveToPosition(position);
        return cursor.getLong(cursor.getColumnIndex(Provider.Students._ID));
    }

    @Override
    public View newView(Context context, Cursor cursor, ViewGroup parent)
    {
        return inflater.inflate(R.layout.list_item_layout, parent, false);

    }

    @Override
    public void bindView(View view, Context context, Cursor cursor)
    {


        ((TextView) view.findViewById(R.id.item_name)).setText(cursor.getString(cursor.getColumnIndex(Provider.Students.NAME)));
        String uco = cursor.getString(cursor.getColumnIndex(Provider.Students.UCO));
        ((TextView) view.findViewById(R.id.item_uco)).setText(uco);
        String description = cursor.getString(cursor.getColumnIndex(Provider.Students.DESCRIPTION));
        ((TextView) view.findViewById(R.id.item_desc)).setText(description);
        ImageView imageView = (ImageView) view.findViewById(R.id.item_image);
//        Picasso.with(context).setDebugging(true);
//        Picasso.with(context).load(cursor.getString(cursor.getColumnIndex(Provider.Students.IMAGE))).error(R.drawable.icon_error).placeholder(R.drawable.icon_bg).into(imageView);


        InputStream is = null;
        Bitmap b = null;
        try
        {
            is = context.openFileInput(uco);
            b = BitmapFactory.decodeStream(is);
        } catch (FileNotFoundException e)
        {
            e.printStackTrace();
        }

        imageView.setImageBitmap(b);

    }

    static class ViewHolder
    {
        private ImageView image;
        private TextView name;
        private TextView uco;
        private TextView description;
    }
}
