package cz.muni.fi.pv239.firstapp.myapplication2.app;

import android.app.IntentService;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;

import com.squareup.okhttp.OkHttpClient;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

import cz.muni.fi.pv239.firstapp.myapplication2.app.database.DatabaseHelper;
import cz.muni.fi.pv239.firstapp.myapplication2.app.database.Provider;


public class RefreshService extends IntentService
{

    public RefreshService()
    {
        super("refresh");
    }

    @Override
    protected void onHandleIntent(Intent intent)
    {
        Log.i("RefreshService","service thread id:"+Thread.currentThread().getId());

//        new Thread(new Runnable()
//        {
//            @Override
//            public void run()
//            {

        try
        {
            final URL url = new URL("https://dl.dropboxusercontent.com/u/30104863/students.json");
            final HttpURLConnection connection = (HttpURLConnection) url.openConnection();
            if (connection.getResponseCode() == 200)
            {
                final BufferedReader r = new BufferedReader(new InputStreamReader(connection.getInputStream()));
                try
                {
                    final StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = r.readLine()) != null)
                    {
                        sb.append(line);
                    }
                    final SQLiteDatabase db = DatabaseHelper.getInstance(RefreshService.this).getWritableDatabase();
                    try
                    {
//                        db.beginTransaction();
                        final JSONObject json = new JSONObject(sb.toString());
                        final JSONArray students = json.getJSONArray("students");
                        Log.i("RefreshService","students:"+students.length());
                        for (int i = 0; i < students.length(); i++)
                        {
                            JSONObject student = students.getJSONObject(i);
                            final ContentValues cv = new ContentValues();
                            cv.put(Provider.Students.NAME, student.getString("name"));
                            cv.put(Provider.Students.UCO, student.getInt("uco"));
                            cv.put(Provider.Students.DESCRIPTION, student.getString("description"));
                            cv.put(Provider.Students.IMAGE, student.getString("image"));
                            db.insertWithOnConflict(DatabaseHelper.TABLE_STUDENTS, null, cv,SQLiteDatabase.CONFLICT_REPLACE);

                            OkHttpClient client = new OkHttpClient();
                            HttpURLConnection urlConnection = client.open(new URL(student.getString("image")));
                            InputStream inputStream  = urlConnection.getInputStream();

                            Bitmap bitmap = BitmapFactory.decodeStream(inputStream);
                            FileOutputStream fos = getBaseContext().openFileOutput(student.getString("uco"), Context.MODE_PRIVATE);
                            bitmap.compress(Bitmap.CompressFormat.PNG, 0, fos);
                            fos.flush();
                            fos.close();
                            getContentResolver().notifyChange(Provider.Students.contentUri(), null);
                        }

//                        db.setTransactionSuccessful();

                    } catch (JSONException e)
                    {
                        Log.e("refresh", "json error " + e.getMessage());
                    } finally
                    {
//                        db.endTransaction();
                    }
                } finally
                {
                    r.close();
                }
            }
        } catch (IOException e)
        {
            Log.e("refresh", "error " + e.getMessage());
        }


//            }
//        }).start();
    }
}