package cz.muni.fi.pv239.firstapp.myapplication2.app.database;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class DatabaseHelper extends SQLiteOpenHelper {

	public static final int DATABASE_VERSION = 1;
	private static final String DATABASE_NAME = "allstudents.db";
	public static final String TABLE_STUDENTS = "students";
	private static DatabaseHelper singleton;
	
	public static DatabaseHelper getInstance(Context context) {
		if (singleton == null) {
			singleton = new DatabaseHelper(context);
		}
		return singleton;
	}
	
	public DatabaseHelper(Context context) {
		super(context, DATABASE_NAME, null, DATABASE_VERSION);
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		StringBuffer sql = new StringBuffer();
		sql.append("CREATE TABLE ");
		sql.append(TABLE_STUDENTS);
		sql.append(" (");
		sql.append(Provider.Students._ID);
		sql.append(" integer primary key autoincrement,");
		sql.append(Provider.Students.NAME);
		sql.append(" text,");
        sql.append(Provider.Students.UCO);
        sql.append(" integer unique,");
        sql.append(Provider.Students.DESCRIPTION);
        sql.append(" text,");
        sql.append(Provider.Students.IMAGE);
        sql.append(" image");
		sql.append(");");
		db.execSQL(sql.toString());

	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int versionOld, int versionNew) {
		Log.d("db", "Upgrading database from version " + versionOld + " to " + versionNew
				+ ", which will preserve existing data");
//		if (versionNew>versionOld) {
//            db.execSQL("DROP TABLE STUDENTS");

//			try {
//				db.beginTransaction();
////				db.execSQL("ALTER TABLE " + TABLE_BOOKS + " ADD " + " ??? TEXT;");
//				db.setTransactionSuccessful();
//				versionOld++;
//			} catch (SQLiteException sqle) {
//				//TODO
//			} finally {
//				db.endTransaction();
//			}
//		}
	}
}
