package cz.muni.fi.pv239.firstapp.myapplication2.app.fragments;

import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.squareup.okhttp.OkHttpClient;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import cz.muni.fi.pv239.firstapp.myapplication2.app.R;
import cz.muni.fi.pv239.firstapp.myapplication2.app.database.Provider;

/**
 * Created by Wendy on 10.3.14.
 */
public class MyDetailFragment extends Fragment
{


    public final static String ARG_POSITION = "position";
    int mCurrentPosition = -1;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState)
    {

        // If activity recreated (such as from screen rotate), restore
        // the previous article selection set by onSaveInstanceState().
        // This is primarily necessary when in the two-pane layout.
        if (savedInstanceState != null)
        {
            mCurrentPosition = savedInstanceState.getInt(ARG_POSITION);
        }

        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.detail_layout, container, false);
    }

    @Override
    public void onStart()
    {
        super.onStart();

        // During startup, check if there are arguments passed to the fragment.
        // onStart is a good place to do this because the layout has already been
        // applied to the fragment at this point so we can safely call the method
        // below that sets the article text.
        Bundle args = getArguments();
        if (args != null)
        {
            // Set article based on argument passed in
            updateView(args.getInt(ARG_POSITION));
        } else if (mCurrentPosition != -1)
        {
            // Set article based on saved instance state defined during onCreateView
            updateView(mCurrentPosition);
        }


    }

    public void updateView(int position)
    {
        mCurrentPosition = position;
        Cursor cursor = getActivity().getContentResolver().query(   Provider.Students.contentUri(),
                                                    new String[]{   Provider.Students.NAME,
                                                                    Provider.Students.UCO,
                                                                    Provider.Students.IMAGE,
                                                                    Provider.Students.DESCRIPTION},
                                                                    Provider.Students._ID + "=?",new String[]{""+position},
                                                                    Provider.Students.DEFAULT_ORDER_BY);

//        cursor.moveToPosition(position);
            cursor.moveToFirst();
        TextView name = (TextView) getActivity().findViewById(R.id.detail_name);
        name.setText(cursor.getString(cursor.getColumnIndex(Provider.Students.NAME)));
        TextView uco =  (TextView) getActivity().findViewById(R.id.detail_uco);
        uco.setText(cursor.getString(cursor.getColumnIndex(Provider.Students.UCO)));
        final ImageView image =  (ImageView) getActivity().findViewById(R.id.detail_image);
        final String url = cursor.getString(cursor.getColumnIndex(Provider.Students.IMAGE));

        Toast.makeText(getActivity(), "loading image for student "+url,Toast.LENGTH_SHORT).show();
//        Picasso.with(getActivity()).load(url).into(image);
        TextView description = (TextView) getActivity().findViewById(R.id.detail_description);
        description.setText(cursor.getString(cursor.getColumnIndex(Provider.Students.DESCRIPTION)));


        //ukayat co sa stane bez asynctasku
        new AsyncTask<Void,Integer,Bitmap>(){

            @Override
            protected Bitmap doInBackground(Void... params)
            {
                OkHttpClient okHttpClient = new OkHttpClient();
                try
                {
                    HttpURLConnection httpURLConnection = okHttpClient.open(new URL(url));
                    InputStream inputStream = httpURLConnection.getInputStream();
                    Bitmap bitmap = BitmapFactory.decodeStream(inputStream);
                    return bitmap;

                } catch (MalformedURLException e)
                {
                    e.printStackTrace();
                } catch (IOException e)
                {
                    e.printStackTrace();
                }
                return null;
            }

            @Override
            protected void onPostExecute(Bitmap bitmap)
            {
                super.onPostExecute(bitmap);
                image.setImageBitmap(bitmap);
            }
        }.execute();



    }

    @Override
    public void onSaveInstanceState(Bundle outState)
    {
        super.onSaveInstanceState(outState);

        // Save the current article selection in case we need to recreate the fragment
        outState.putInt(ARG_POSITION, mCurrentPosition);
    }

}
